import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import java.awt.*;
import java.util.StringTokenizer;

public class Server {

    Vector room=new Vector();
  /** Start the server up, listening on an optionally specified port */
    public Server(int port) 
    {
        Socket client_socket;
        ServerSocket listen_socket=null;
	System.out.println("Server Started");

        try { listen_socket = new ServerSocket(port); }
        catch (IOException e) {System.out.println("Exception creating server socket"); System.exit(255);}

        try {
                while(true) 
		{
                	client_socket = listen_socket.accept();
			// try { 
			room.addElement(new Connection(this, client_socket));
			// } catch (IOException e) {};
		}
            }
        catch (IOException e) {System.out.println("Exception while listening for connections");}
    }

    public static void main(String[] args) 
    {
	int p=7656;
	if (args.length==1)
	{
	   try { p = Integer.parseInt(args[0]); }
           catch (NumberFormatException e) { p=7656; }
	};
	new Server(p);
    }
}


class Connection extends Thread 
{
    BufferedReader in;
    PrintWriter out;
    Vector r;

    public Connection(Server theserver, Socket client_socket) 
    {
        r = theserver.room;

        try 
        { 
           in = new BufferedReader (
                   new InputStreamReader (
                       client_socket.getInputStream()));
           out = new PrintWriter (
                    new BufferedWriter (
                        new OutputStreamWriter(
                            client_socket.getOutputStream())),true);
        }  catch (IOException e) 
        {
            try { out.close(); in.close(); } 
            catch (IOException e2) {} ;
            System.err.println("Exception while getting socket streams: " + e);
            return;
        }
	
        this.start();
    }

    public void run() 
    {
        String line;
        int i;
        try 
        {
            while (true)
	    {
                yield();
                line = in.readLine();
                if (line == null) break;
                 
                for (i=0; i<r.size(); i++)
                    ((Connection)r.elementAt(i)).out.println(line);
                    
	    };
        }
        catch (IOException e) {	}
        finally 
	{
            try {out.close(); in.close(); } 
            catch (IOException e2) { System.out.println("Yow!");};
            r.removeElement(this);
        };
    }
}

